# botf/__init__.py
#
#

""" unit. """

__copyright__ = "Copyright 2015, B.H.J Thate"
__version__ = "1"

## IMPORTS

from botf.utils.parse import txt_parse
from botf.utils.time import short_date
from botf.defines import BLA, ENDC
from botf.dispatcher import Dispatcher
from botf.kernel import kernel, fleet
from botf.thing import Thing

from botf.errors import RemoteDisconnect, NotImplemented

import logging
import socket
import time

## BOTFS

class Bot(Dispatcher):

    """ Basic Bot. """

    default = ""
    cc = ""

    def __init__(zelf, *args, **kwargs):
        Dispatcher.__init__(zelf, *args, **kwargs)
        zelf._start = time.time()
        zelf.channels = ["#botf", ]

    def say(zelf, *args, **kwargs): print(args[1])
        
    ## CHANNELS

    def announce(zelf, *args, **kwargs):
        """ announce on channels. """
        zelf._last = time.time()
        logging.info("# announce %s" % " ".join(zelf.channels))
        for channel in zelf.channels: zelf.say(channel, args[0])

    def event(zelf, *args, **kwargs):
        event = Thing()
        event._target = zelf
        event.origin = "root@zelf"
        event.txt = args[0]
        return event

    def join(zelf, *args, **kwargs): pass
        
    def joining(zelf, *args, **kwargs):
        """ join channels.  """ 
        for channel in zelf.channels: zelf.join(channel)
            
## TESTBOTF

class TestBot(Bot):

    """ USE WITH Bot.put() and Bot.read(). """

    testing = True
    cc = "!"
    default = ""

    def say(zelf, *args, **kwargs): logging.warn(args[1])

    def event(zelf, *args, **kwargs):
        o = Thing()
        o.origin = "test@botf"
        o._target = zelf
        o.loglevel = "warning"
        o.txt = args[0]
        o.parsed = txt_parse(zelf, o.txt)
        return o

## CMNDS

def join(event):
    if not event.parsed.args: return
    channel = event.parsed.args[0]
    for botf in fleet:
        if "join" not in botf: continue
        botf.join(channel)
        event.reply("join %s (%s)" % (channel, botf.server))

kernel.register("botf.join", join)

def part(event):
    if not event.parsed.args: return
    for botf in fleet:
        try: botf.part(event.parsed.args[0])
        except: continue
        event.reply("part %s (%s)" % (channel, botf.server))

kernel.register("botf.part", part)

def nick(event):
    if not event.parsed.args: return
    for botf in fleet:
        try: botf.nick(event.parsed.args[0])
        except: continue
        event.reply("nick %s" % botf.server)

kernel.register("botf.nick", nick)

def quit(event):
    if not event.parsed.args: return
    for botf in fleet:
        try: botf.quit(event.parsed.rest)
        except: continue
        event.reply("quit %s" % botf.server)
    
kernel.register("botf.quit", quit)
